// Generated by CoffeeScript 1.9.3
var Attr, Container, FindType, preparePageOptions, ref;

Attr = require('./attr');

ref = require('./util'), preparePageOptions = ref.preparePageOptions, FindType = ref.FindType;

Container = (function() {
  function Container(_pageUrl, _scraper, _findType) {
    this._pageUrl = _pageUrl;
    this._scraper = _scraper;
    this._findType = _findType;
    this._index = 0;
    this._attrName = 'href';
    this._finalUrl = this._pageUrl;
  }

  Container.prototype.page = function(attrName, options) {
    var targetAttr, targetOptions, url;
    targetAttr = 'href';
    targetOptions = {};
    if (typeof attrName === 'object') {
      targetAttr = 'href';
      targetOptions = attrName;
    } else if (typeof attrName === 'string') {
      targetAttr = attrName;
      targetOptions = options;
    }
    url = this._getAttr(targetAttr);
    targetOptions = preparePageOptions(this._finalUrl, targetOptions);
    return require('./core').page(url, targetOptions);
  };

  Container.prototype._getAttr = function(attrName, index) {
    var _attr, e;
    if (attrName == null) {
      attrName = this._attrName;
    }
    if (index == null) {
      index = this._index;
    }
    if (index < 0) {
      index = this._find.length + index;
    }
    try {
      if (this._findType === FindType.cheerio) {
        _attr = this._find[index].attribs[attrName];
      } else if (this._findType === FindType.xpath) {
        _attr = this._find.attributes.getNamedItem(attrName).value;
      }
    } catch (_error) {
      e = _error;
      throw new Error("Could not find attribute '" + attrName + "' at element index '" + index + "'");
    }
    return _attr;
  };

  Container.prototype.attr = function(attrName, index, _attr) {
    if (_attr == null) {
      _attr = this._getAttr(attrName, index);
    }
    return new Attr(this._finalUrl, this._find, this._findType, _attr);
  };

  Container.prototype.all = function(attrName) {
    var i, index, ref1, results;
    if (this._findType === FindType.cheerio) {
      results = [];
      for (index = i = 0, ref1 = this._find.length - 1; 0 <= ref1 ? i <= ref1 : i >= ref1; index = 0 <= ref1 ? ++i : --i) {
        results.push(this.attr(attrName, index));
      }
      return results;
    } else {
      return [attr(attrName)];
    }
  };

  Container.prototype.href = function() {
    return this.attr('href');
  };

  Container.prototype.text = function() {
    var _attr;
    if (this._findType === FindType.cheerio) {
      _attr = this._find.index(this._index).text();
    } else if (this._findType === FindType.xpath) {
      _attr = this._find.textContent;
    }
    return attr(null, null, _attr);
  };

  Container.prototype.index = function(index) {
    this._index = index;
    return this;
  };

  Container.prototype.download = function() {
    var attrInstance;
    attrInstance = this.href();
    return attrInstance.download.apply(attrInstance, arguments);
  };

  return Container;

})();

module.exports = Container;
