// Generated by CoffeeScript 1.9.3
var Container, DOMParser, Extractor, FindType, Promise, _extend, getDocument, ref, xpath;

Container = require('./container');

xpath = require('xpath');

DOMParser = require('xmldom').DOMParser;

Promise = require('bluebird');

ref = require('./util'), FindType = ref.FindType, getDocument = ref.getDocument;

_extend = require('util')._extend;

Extractor = (function() {
  function Extractor(_url, _options) {
    var defaultOptions;
    this._url = _url;
    this._options = _options;
    if (this._options == null) {
      this._options = {};
    }
    defaultOptions = {
      url: this._url
    };
    this._options = _extend(defaultOptions, this._options);
    if (this._options.pageUrlAsReferrer === true) {
      if (this._options.headers == null) {
        this._options.headers = {};
      }
      if (this._options.hasOwnProperty('previousUrl')) {
        this._options.headers.referer = this._options.previousUrl;
      } else {
        this._options.headers.referer = this._url;
      }
    }
    this._scraper = getDocument({
      uri: this._options.url,
      headers: this._options.headers
    });
  }

  Extractor.prototype.find = function(query, callback) {
    var container, thisClass;
    container = new Container(this._url, this._scraper, FindType.cheerio);
    thisClass = this;
    return thisClass._scraper.then(function(res) {
      container._find = res.$(query);
      container._finalUrl = res.finalUrl;
      if (typeof callback === 'function') {
        callback(container);
      }
      return container;
    });
  };

  Extractor.prototype.findXpath = function(query, callback) {
    var container, thisClass;
    container = new Container(this._url, this._scraper, FindType.xpath);
    thisClass = this;
    return thisClass._scraper.then(function(res) {
      var doc, nodes;
      doc = new DOMParser().parseFromString(res.body, 'text/html');
      nodes = xpath.select(query, doc);
      container._find = nodes;
      if (typeof callback === 'function') {
        return callback(container);
      }
    });
  };

  return Extractor;

})();

module.exports = Extractor;
