// Generated by CoffeeScript 1.9.3
var Core, FindType, OnParser, Parser, _extend, extname, isAbsolute, join, normalize, ref, replacer,
  extend1 = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

Core = require('./core');

ref = require('path'), extname = ref.extname, join = ref.join, isAbsolute = ref.isAbsolute, normalize = ref.normalize;

FindType = require('./util').FindType;

replacer = require('./replacer');

_extend = require('util')._extend;

OnParser = (function() {
  function OnParser() {}

  OnParser.prototype.onDownload = function(fn) {
    this._onDownload = fn;
    return this;
  };

  OnParser.prototype.onExtract = function(fn) {
    this._onExtract = fn;
    return this;
  };

  OnParser.prototype.parse = function(obj) {
    if (typeof obj !== 'object') {
      throw new Error('You need to provide an object or an array');
    }
    this._obj = obj;
    this._parse();
    return this;
  };

  OnParser.prototype._parse = function(obj, extend) {
    if (obj == null) {
      obj = this._obj;
    }
    obj = Array.isArray(obj) ? obj : [obj];
    return this._iterate(obj, extend);
  };

  OnParser.prototype._iterate = function(obj, extend) {
    return obj.forEach((function(_this) {
      return function(i) {
        i = _extend(i, extend);
        return _this._iterateItem(i);
      };
    })(this));
  };

  OnParser.prototype._iterateItem = function(item) {
    var attr, containerPromise, directory, execute, extract, filename, filenameMode, find, findIndex, findType, ref1, ref10, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9, thenObj, url, useText;
    url = item.url;
    find = item.find;
    findIndex = (ref1 = item.findIndex) != null ? ref1 : 0;
    findType = FindType[(ref2 = item.findType) != null ? ref2 : 'cheerio'];
    attr = (ref3 = item.attr) != null ? ref3 : 'href';
    useText = (ref4 = item.text) != null ? ref4 : false;
    thenObj = (ref5 = item.then) != null ? ref5 : false;
    filename = (ref6 = item.filename) != null ? ref6 : false;
    filenameMode = (ref7 = item.filenameMode) != null ? ref7 : ['urlBasename', 'contentType'];
    directory = (ref8 = item.directory) != null ? ref8 : '';
    execute = (ref9 = item.execute) != null ? ref9 : false;
    extract = (ref10 = item.extract) != null ? ref10 : false;
    containerPromise = Core.page(url).find(find);
    return containerPromise.then((function(_this) {
      return function(containerInstance) {
        var attrInstance, downloadOptions, extend, fileInstance;
        if (findIndex !== 0) {
          containerInstance = containerInstance.index(findIndex);
        }
        if (useText === true) {
          attrInstance = containerInstance.text();
        } else {
          attrInstance = containerInstance.attr(attr);
        }
        if (thenObj !== false) {
          extend = {
            url: attrInstance.value()
          };
          return _this._parse(thenObj, extend);
        }
        downloadOptions = {};
        downloadOptions.filenameMode = filenameMode;
        downloadOptions.directory = replacer.replace(directory);
        [].concat(filenameMode).forEach(function(i) {
          return downloadOptions.filenameMode[i] = true;
        });
        if (typeof filename === 'string') {
          downloadOptions.filenameMode['predefined'] = filename;
        }
        fileInstance = attrInstance.download(downloadOptions, _this._onDownload);
        if (execute !== false) {
          fileInstance.execute(execute);
        }
        if (extract !== false) {
          if (extract.to != null) {
            extract.to = replacer.replace(extract.to);
          }
          return fileInstance.extract(extract, _this._onExtract);
        }
      };
    })(this));
  };

  return OnParser;

})();

Parser = (function(superClass) {
  extend1(Parser, superClass);

  function Parser() {
    return Parser.__super__.constructor.apply(this, arguments);
  }

  Parser.prototype._getObj = function(filepath) {
    var ext, obj, realfilepath;
    if (typeof filepath === 'object') {
      obj = filepath;
    } else {
      realfilepath = isAbsolute(filepath) ? filepath : join(process.cwd(), filepath);
      ext = extname(filepath);
      if (ext === '.json') {
        obj = require(realfilepath);
      } else if (ext === '.yml') {
        obj = YAML.load(realfilepath);
      }
    }
    return obj;
  };

  Parser.prototype.parse = function(filepath) {
    var obj;
    obj = this._getObj(filepath);
    return Parser.__super__.parse.call(this, obj);
  };

  return Parser;

})(OnParser);

module.exports = Parser;
