// Generated by CoffeeScript 1.9.3
var normalize, replacer, tmpdir;

tmpdir = require('os').tmpdir;

normalize = require('path').normalize;

replacer = {
  patterns: {
    tmpdir: {
      find: '%tmpdir%',
      replace: tmpdir,
      after: normalize
    },
    env: {
      find: /%env:(\w+)%/gi,
      replace: function(m, g1) {
        return process.env[g1];
      }
    }
  },
  createRegex: function(str) {
    if (typeof str === 'string') {
      return new RegExp(str, 'gi');
    } else if (str instanceof RegExp) {
      return str;
    } else {
      throw new Error('This is not a string nor RegExp');
    }
  },
  replace: function(str) {
    var find, item, key, oldStr, ref;
    oldStr = str;
    ref = replacer.patterns;
    for (key in ref) {
      item = ref[key];
      find = replacer.createRegex(item.find);
      if (find.test(str)) {
        str = str.replace(find, item.replace);
        [].concat(item.after).filter(function(i) {
          return typeof i === 'function';
        }).forEach(function(fix) {
          return str = fix(str);
        });
      }
    }
    return str;
  }
};

module.exports = replacer;
